| D++ (DPP) C++ Discord API Bot Library

Search
Loading...
Searching...
No Matches
dpp::command_permission Class Reference

Application command permissions allow you to enable or disable commands for specific users or roles within a guild. More...

`#include <appcommand.h>`

Inheritance diagram for dpp::command_permission:
[legend]
Collaboration diagram for dpp::command_permission:
[legend]

## Public Member Functions

| command_permission ()=default
| Construct a new command permission object.
| command_permission (snowflake id, const command_permission_type t, bool permission)
| Construct a new command permission object.
virtual | ~command_permission ()=default
std::string | build_json (bool with_id=false) const
| Convert object to json string.
command_permission & | fill_from_json (nlohmann::json *j)
| Convert object from nlohmann::json.
auto | to_json (bool with_id=false) const
| Convert object to nlohmann::json.

## Public Attributes

snowflake | id
| The ID of the role/user.
bool | permission
| True to allow, false to disallow.
command_permission_type | type
| The type of permission.

## Protected Member Functions

command_permission & | fill_from_json_impl (nlohmann::json *j)
| Fill object properties from JSON.

## Friends

struct | json_interface< command_permission >

## Detailed Description

Application command permissions allow you to enable or disable commands for specific users or roles within a guild.

## Constructor & Destructor Documentation

## ◆ command_permission() [1/2]

dpp::command_permission::command_permission | ( |  | ) |

default

Construct a new command permission object.

## ◆ ~command_permission()

virtual dpp::command_permission::~command_permission | ( |  | ) |

virtual default

## ◆ command_permission() [2/2]

dpp::command_permission::command_permission | ( | snowflake | id,
|  | const command_permission_type | t,
|  | bool | permission )

Construct a new command permission object.

Parameters

  id | The ID of the role or user
  t | The permission type
  permission | True to allow, false, to disallow

## Member Function Documentation

## ◆ build_json()

std::string dpp::json_interface< command_permission >::build_json | ( | bool | with_id = false | ) | const

inline inherited

Convert object to json string.

Parameters

  with_id | Whether to include the ID or not

Note
  Some fields are conditionally filled, do not rely on all fields being present

Returns
  std::string Json built from the structure

## ◆ fill_from_json()

command_permission & dpp::json_interface< command_permission >::fill_from_json | ( | nlohmann::json * | j | ) |

inline inherited

Convert object from nlohmann::json.

Parameters

  j | nlohmann::json object

Returns
  T& Reference to self for fluent calling

## ◆ fill_from_json_impl()

command_permission & dpp::command_permission::fill_from_json_impl | ( | nlohmann::json * | j | ) |

protected

Fill object properties from JSON.

Parameters

  j | JSON to fill from

Returns
  command_permission& Reference to self

## ◆ to_json()

auto dpp::json_interface< command_permission >::to_json | ( | bool | with_id = false | ) | const

inline inherited

Convert object to nlohmann::json.

Parameters

  with_id | Whether to include the ID or not

Note
  Some fields are conditionally filled, do not rely on all fields being present

Returns
  json Json built from the structure

## Friends And Related Symbol Documentation

## ◆ json_interface< command_permission >

friend struct json_interface< command_permission >

friend

## Member Data Documentation

## ◆ id

snowflake dpp::command_permission::id

The ID of the role/user.

## ◆ permission

bool dpp::command_permission::permission

True to allow, false to disallow.

## ◆ type

command_permission_type dpp::command_permission::type

The type of permission.

D++ Library version 9.0.13 D++ Library version 9.0.12 D++ Library version 9.0.11 D++ Library version 9.0.10 D++ Library version 9.0.9 D++ Library version 9.0.8 D++ Library version 9.0.7 D++ Library version 9.0.6 D++ Library version 9.0.5 D++ Library version 9.0.4 D++ Library version 9.0.3 D++ Library version 9.0.2 D++ Library version 9.0.1 D++ Library version 9.0.0 D++ Library version 1.0.2 D++ Library version 1.0.1 D++ Library version 1.0.0